//+------------------------------------------------------------------+
//|                                                   Adaptation.mq5 |
//|                                                        AIS Forex |
//|                        https://www.mql5.com/en/users/aleksej1966 |
//+------------------------------------------------------------------+
#property copyright "AIS Forex"
#property link      "https://www.mql5.com/en/users/aleksej1966"
#property version   "1.00"
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_plots   1

#property indicator_type1  DRAW_LINE
#property indicator_label1 "Adaptation"
#property indicator_color1 clrBlue
#property indicator_width1 1
#property indicator_style1 STYLE_SOLID

#property indicator_applied_price PRICE_CLOSE

input ushort iPeriod=14,
             Parametr=0;
ushort N=2,p;
double buffer[],coeff[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,buffer,INDICATOR_DATA);
   ArraySetAsSeries(buffer,true);
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);

   N=MathMax(N,iPeriod);

   ArrayResize(coeff,N);
   ArrayInitialize(coeff,1.0/N);

   p=Parametr==0?N:Parametr;
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
//---
   ArraySetAsSeries(price,true);

   int bars=prev_calculated>0? rates_total-prev_calculated:rates_total-N-2;

   for(int i=bars; i>=0; i--)
     {
      if(rates_total>prev_calculated)
        {
         double indicator=0,M=p;
         for(int j=1; j<=N; j++)
           {
            indicator=indicator+coeff[j-1]*price[i+j];
            M=M+MathPow(price[i+j],2);
           }
         double error=price[i+1]-indicator;

         for(int j=1; j<=N; j++)
            coeff[j-1]=coeff[j-1]+price[i+j]*error/M;
        }

      double indicator=0;
      for(int j=0; j<N; j++)
         indicator=indicator+coeff[j]*price[i+j];

      buffer[i]=indicator;
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
