//+------------------------------------------------------------------+
//|                                                 Adaptive EMA.mq4 |
//|                                                        AIS Forex |
//|                        https://www.mql5.com/en/users/aleksej1966 |
//+------------------------------------------------------------------+
#property copyright "AIS Forex"
#property link      "https://www.mql5.com/en/users/aleksej1966"
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_plots   1

#property indicator_type1  DRAW_LINE
#property indicator_label1 "Adaptive EMA"
#property indicator_color1 clrBlue
#property indicator_width1 1
#property indicator_style1 STYLE_SOLID

input ENUM_APPLIED_PRICE iPrice=PRICE_CLOSE;
input ushort Parameter=1;
ushort p=1;
double buffer[],c1=0.5,c2=0.5;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,buffer,INDICATOR_DATA);
   ArraySetAsSeries(buffer,true);
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);

   p=MathMax(p,Parameter);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   ArraySetAsSeries(open,true);
   ArraySetAsSeries(high,true);
   ArraySetAsSeries(low,true);
   ArraySetAsSeries(close,true);

   int bars=rates_total-prev_calculated;

   if(prev_calculated==0)
     {
      bars=rates_total-3;
      buffer[rates_total-1]=price(open[rates_total-1],high[rates_total-1],low[rates_total-1],close[rates_total-1]);
     }

   for(int i=bars; i>=0; i--)
     {
      if(rates_total>prev_calculated)
        {
         int p1=i+1;
         double m=p+MathPow(price(open[p1],high[p1],low[p1],close[p1]),2)+MathPow(buffer[i+2],2),
                error=(1-c1)*price(open[p1],high[p1],low[p1],close[p1])-c2*buffer[i+2];

         c1=c1+price(open[p1],high[p1],low[p1],close[p1])*error/m;
         c2=c2+buffer[i+2]*error/m;
        }

      buffer[i]=c1*price(open[i],high[i],low[i],close[i])+c2*buffer[i+1];
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double price(double o,double h,double l,double c)
  {
   if(iPrice==PRICE_CLOSE)
      return(c);
   if(iPrice==PRICE_OPEN)
      return(o);
   if(iPrice==PRICE_HIGH)
      return(h);
   if(iPrice==PRICE_LOW)
      return(l);
   if(iPrice==PRICE_MEDIAN)
      return((h+l)/2);
   if(iPrice==PRICE_TYPICAL)
      return(h+l+c)/3;
   return(h+l+2*c)/4;
  }
//+------------------------------------------------------------------+
