//+------------------------------------------------------------------+
//|                                                      Moonset.mq4 |
//|                                                        AIS Forex |
//|                        https://www.mql5.com/en/users/aleksej1966 |
//+------------------------------------------------------------------+
#property copyright "AIS Forex"
#property link      "https://www.mql5.com/en/users/aleksej1966"
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_plots   1

#property indicator_type1  DRAW_LINE
#property indicator_label1 "Moonset"
#property indicator_color1 clrBlue
#property indicator_width1 1
#property indicator_style1 STYLE_SOLID

input ENUM_APPLIED_PRICE iPrice=PRICE_CLOSE;
enum type {Linear,Quadratic,Exponential};
input type Smoothing=Linear;
input ushort iPeriod=15,
             iCenter=1;
int period,center;
double buffer[],weight[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,buffer,INDICATOR_DATA);
   ArraySetAsSeries(buffer,true);
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);

//---
   period=MathMax(2,iPeriod);
   ArrayResize(weight,period);

   center=iCenter-1;
   if(center<0 || center>period-1)
      center=period/2;
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   ArraySetAsSeries(open,true);
   ArraySetAsSeries(high,true);
   ArraySetAsSeries(low,true);
   ArraySetAsSeries(close,true);

   int bars=prev_calculated>0?rates_total-prev_calculated:rates_total-period-1;

   for(int i=bars; i>=0; i--)
     {
      double value=price(open[i+center],high[i+center],low[i+center],close[i+center]),
             max=_Point;
      for(int j=0; j<period; j++)
        {
         int p=i+j;
         weight[j]=MathAbs(value-price(open[p],high[p],low[p],close[p]));
         max=MathMax(max,weight[j]);
        }

      double width=(period+1)*max/period,
             sum=0,
             denom=0;
      for(int j=0; j<period; j++)
        {
         if(Smoothing==Linear)
            weight[j]=1-weight[j]/width;
         if(Smoothing==Quadratic)
            weight[j]=1-MathPow(weight[j]/width,2);
         if(Smoothing==Exponential)
            weight[j]=MathExp(-weight[j]/width);
         int p=i+j;
         sum=sum+weight[j]*price(open[p],high[p],low[p],close[p]);
         denom=denom+weight[j];
        }

      buffer[i]=sum/denom;
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double price(double o,double h,double l,double c)
  {
   if(iPrice==PRICE_CLOSE)
      return(c);
   if(iPrice==PRICE_OPEN)
      return(o);
   if(iPrice==PRICE_HIGH)
      return(h);
   if(iPrice==PRICE_LOW)
      return(l);
   if(iPrice==PRICE_MEDIAN)
      return((h+l)/2);
   if(iPrice==PRICE_TYPICAL)
      return(h+l+c)/3;
   return(h+l+2*c)/4;
  }
//+------------------------------------------------------------------+
